unit acces95;

interface

uses
  Windows,
  SysUtils,
  Classes;

function Win_InPortB(Address: WORD): WORD;
function Win_InPort(Address: WORD): WORD;
function Win_InPortL(Address: WORD): DWORD;
function Win_OutPortB(Address: WORD; Value: BYTE): WORD;
function Win_OutPort(Address: WORD; Value: WORD): WORD;
function Win_OutPortL(Address: WORD; Value: DWORD): WORD;

function Win_INSB(Port, Count: LongWord; var pBuffer:     Byte): LongWord; cdecl;
function Win_INSW(Port, Count: LongWord; var pBuffer:     Word): LongWord; cdecl;
function Win_INSD(Port, Count: LongWord; var pBuffer: LongWord): LongWord; cdecl;

implementation

function Win_InPortB(Address: WORD): WORD;
var
    Value: Byte;
begin
    asm
        mov     dx,Address
        in      al,dx
        mov     Value,al
    end;
    Result := Value;
end;

function Win_InPort(Address: WORD): WORD;
var
    Value: WORD;
begin
    asm
        mov     dx,Address
        in      ax,dx
        mov     Value,ax
    end;
    Result := Value;
end;

function Win_InPortL(Address: WORD): DWORD;
var
    Value: DWORD;
begin
    asm
        mov     dx,Address
        in      eax,dx
        mov     Value,eax
    end;
    Result := Value;
end;

function Win_OutPortB(Address: WORD; Value: BYTE): WORD;
begin
    asm
        mov     al,Value
        mov     dx,Address
        out     dx,al
    end;
    Result := 0;
end;

function Win_OutPort(Address: WORD; Value: WORD): WORD;
begin
    asm
        mov     ax,Value
        mov     dx,Address
        out     dx,ax
    end;
    Result := 0;
end;

function Win_OutPortL(Address: WORD; Value: DWORD): WORD;
begin
    asm
        mov     eax,Value
        mov     dx,Address
        out     dx,eax
    end;
    Result := 0;
end;

function Win_INSB(Port, Count: LongWord; var pBuffer:     Byte): LongWord;
asm
  mov EAX, ERROR_NOT_SUPPORTED
end;

function Win_INSW(Port, Count: LongWord; var pBuffer:     Word): LongWord;
asm
  mov EAX, ERROR_NOT_SUPPORTED
end;

function Win_INSD(Port, Count: LongWord; var pBuffer: LongWord): LongWord;
asm
  mov EAX, ERROR_NOT_SUPPORTED
end;

end.
